import java.awt.*;
import java.awt.geom.*;

public class Dreieck extends Figur
{
	public int breite, hhe, oben, links;
	private int l[];
	private int o[];
	private int x, y;
	private boolean neu=true;

	public Dreieck()
	{
		breite=100;
		hhe=100;
		links=20;
		oben=20;
		farbe=Color.black;

		addArg(new Argument("links","20","Abstand vom linken Rand","xmin"));
		addArg(new Argument("oben","20","Abstand vom oberen Rand","ymin"));
		addArg(new Argument("breite","100","Breite des Dreiecks","adx"));
		addArg(new Argument("hhe","100","Hhe des Dreiecks (negativ: Spitze oben)","dy"));
	}

	public Shape getShape()
	{
		GeneralPath p=new GeneralPath();
		if(hhe>0)
		{
			p.moveTo(links,oben);
			p.lineTo(links+breite,oben);
			p.lineTo(links+(int)(breite/2),oben+hhe);
		}
		else
		{
			p.moveTo(links,oben-hhe);
			p.lineTo(links+breite,oben-hhe);
			p.lineTo(links+(int)(breite/2),oben);
		}
		p.closePath();
		return p;
	}
	public Dimension getMittelpunkt()
	{
		return new Dimension(links+(int)(breite/2),oben+Math.abs((int)(hhe/2)));
	}
	public void verschiebe(int dx, int dy)
	{
		if(neu)
		{
			x=links*faktor;
			y=oben*faktor;
			neu=false;
		}
		x+=dx*faktor;
		y+=dy*faktor;
		links+=dx;
		oben+=dy;
	}
	public void verschiebe1(int dx, int dy)
	{
		if(neu)
		{
			x=links*faktor;
			y=oben*faktor;
			neu=false;
		}
		x+=dx;
		y+=dy;
		links=(int)x/faktor;
		oben=(int)y/faktor;
	}
	public void setGrenzen()
	{
		xmin=links;
		xmax=links+breite;
		if(hhe>0)
		{
			ymin=oben;
			ymax=oben+hhe;
		}
		else
		{
			ymax=oben;
			ymin=oben+hhe;
		}
	}
}
